﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Media.Animation;

using DevExpress.Xpf.Grid;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.gridControl.ItemsSource = GetData();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 테이블 뷰 커스텀 스크롤 애니메이션 처리하기 - tableView_CustomScrollAnimation(sender, e)

        /// <summary>
        /// 테이블 뷰 커스텀 스크롤 애니메이션 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void tableView_CustomScrollAnimation(object sender, CustomScrollAnimationEventArgs e)
        {
            e.Storyboard = new Storyboard();

            DoubleAnimation animation = new DoubleAnimation();

            animation.Duration       = new Duration(TimeSpan.FromMilliseconds(200));
            animation.From           = e.OldOffset;
            animation.To             = e.NewOffset;
            animation.EasingFunction = new ExponentialEase() { Exponent = 0 };

            e.Storyboard.Children.Add(animation);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 데이터 구하기 - GetData()

        /// <summary>
        /// 데이터 구하기
        /// </summary>
        /// <returns>샘플 리스트</returns>
        private List<Sample> GetData()
        {
            List<Sample> list = new List<Sample>();

            for(int i = 0; i < 100; i++)
            {
                list.Add(new Sample() { ID = i, Value = string.Format("Value {0}", i)  });
            }

            return list;
        }

        #endregion
    }
}